var zpoolsinfo = [];
var send_reqstatus = 0;
var recv_reqstatus = 0;
var errcode = {
  9984 : 'Not logged in yet',
  9985 : 'Unknown interface',
  9972 : 'Interface not running',
  9898 : 'Connection Failed'
}

function refreshTreeNode_lvm(target, node) {
  var id = node.id;
  var jsonstr = "[]";
  var jsonarray = eval('(' + jsonstr + ')');
  var ref = jQuery(target).jstree(true);
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    timeout: 300000,
    dataType: "json",
    data: JSON.stringify({
      cmd: "folder_loadby",
      token: UToken,
      params: {
        dir: id
      }
    }),
    success: function(result) {
      var arrays = result.results.records || [];
      node.children = [];
      for (var i = 0; i < arrays.length; i++) {
        var arr = {
          "id": arrays[i].path,
          "text": arrays[i].foldername,
          "parent": arrays[i].path,
          "type": "folder",
          "state": {
            "opened": false,
            "selected": false
          },
        }

        ref.create_node(node, arr, "last");
      }
      ref.open_node(node);

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);

    }
  });
}

function initTreeData_lvm(target, sf, fn) {
  jQuery(target).jstree({
    "core": {
      'data': function(obj, callback) {
        var jsonstr = "[]";
        var jsonarray = eval('(' + jsonstr + ')');
        var url = 'xxxxxxxxxxxx/xxxxxxxxx';
        jQuery.ajax({
          type: "POST",
          url: "/wmi/index.php",
          dataType: "json",
          cache: false,
          timeout: 30000,
          data: JSON.stringify({
            cmd: "sharefolder_alload",
            token: UToken
          }),
          success: function(data) {
            var arrays = data.results.folders || [];
            for (var i = 0; i < arrays.length; i++) {
              var arr = {
                "id": arrays[i].path,
                "text": arrays[i].folder,
                "parent": "#",
                "type": "folder",
                "state": {
                  "opened": false,
                  "selected": false
                },
              }
              jsonarray.push(arr);
            }

            callback.call(this, jsonarray);

          }.bind(this),
          error: function(XMLHttpRequest, textStatus, errorThrown) {

          }

        });
      }.bind(this),
      "themes": {
        "variant": "large", //加大
        "ellipsis": true, //文字多时省略
        dots: true //取消连接线
      },
      'expand_selected_onload': false, //加载完成后默认展开所有选中节点true为选中 false为不展开
      "check_callback": true
    },

    //"plugins" : [ "wholerow","themes","types","ui","json_data"]
    "plugins": ["wholerow"]
  }).on('select_node.jstree', function(event, data) {
    refreshTreeNode_lvm(target, data.node);
    jQuery(sf).val(data.node.id);

    if (fn && typeof fn === "function") {
      fn();
    }

  }).on('changed.jstree', function(event, data) {

  });
}


function arrTrans(num, arr) {
  const iconsArr = [];
  arr.forEach((item, index) => {
    const page = Math.floor(index / num);
    if (!iconsArr[page]) {
      iconsArr[page] = [];
    }
    iconsArr[page].push(item);
  });
  return iconsArr;
}

function showPageList() {
  var ev = window.event || arguments.callee.caller.arguments[0];
  ev.stopPropagation();
  var node = jQuery(ev.currentTarget).parent('.pageitemcon');
  node.find('.pageList').slideToggle();

  document.onclick = function(e) {
    e.stopPropagation();
    jQuery('.pageList').slideUp();
  }
}

function seteChart(t, v, bg) {
  var chart = echarts.init(t);
  var option = {
    series: [{
      type: 'gauge',
      startAngle: -270,
      endAngle: 90,
      min: 0,
      max: 100,
      splitNumber: 1,
      center: ['50%', '50%'],
      radius: '100%',
      itemStyle: {
        color: bg,
      },
      progress: {
        show: true,
        width: 3,
      },
      axisLine: {
        color: '#e9e9e9',
        lineStyle: {
          width: 3,
        }
      },
      axisTick: {
        show: false
      },
      pointer: {
        show: false
      },
      splitLine: {
        show: false,
      },
      axisLabel: {
        show: false
      },
      detail: {
        offsetCenter: [9, '10%'],
        valueAnimation: true,
        formatter: function(value) {
          return '{value|' + Math.round(value) + '%}  ';
        },
        rich: {
          value: {
            textAlign: 'center',
            fontSize: 8,
            fontWeight: 400,
            color: '#222'
          }
        }
      },
      data: [{
        value: v
      }]
    }]
  };
  option && chart.setOption(option);
}

function lvmnav(t, et) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  if (et) {
    that = jQuery(et);
  }
  that.attr('class', 'unas_tab_sel').siblings().attr('class', 'unas_tab');
  jQuery('#jv-lvm-' + t).fadeIn().siblings().hide();
  if (t != 'manager') {
    jQuery('#jv-lvm-' + t).load('/apps/lvm/snapshot/' + t);
  }
}

function lvm_manager_waiting_show() {
  jQuery('#lvm_manager_waiting_content').show();
  jQuery('#lvm_manager_waiting_logo').show();
}

function lvm_manager_waiting_hide() {
  jQuery('#lvm_manager_waiting_content').hide();
  jQuery('#lvm_manager_waiting_logo').hide();
}

function lvmTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

function formatDate_vm(d) {
  if (!d) {
    return '--';
  }
  var date = new Date(d * 1000);
  var YY = date.getFullYear() + '-';
  var MM = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
  var DD = (date.getDate() < 10 ? '0' + (date.getDate()) : date.getDate());
  var hh = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
  var mm = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
  var ss = (date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds());
  return YY + MM + DD + " " + hh + mm;
};

//提示弹窗
function tipBox(msg) {
  if (!msg) {
    return;
  }
  jQuery('#jv-messageBox').remove();
  var divF = "<div id='jv-messageBox' class='messageBox'></div>";
  jQuery('body').append(divF);
  jQuery('#jv-messageBox').empty();
  var div = "<div class='tip'><span></span></div>";
  jQuery('#jv-messageBox').append(div);

  jQuery(".tip").css('left', '0');
  jQuery('.tip').fadeIn(1000);
  jQuery(".tip span").html(msg);
  var h = +jQuery(".tip span").height();
  jQuery(".tip").css('top', (getClientHeight() / 2 - h)+ "px");
  setTimeout(function() {
    jQuery('#jv-messageBox').fadeOut();
  }, 3000);
}

function getClientHeight() {
  var clientHeight = 0;
  if (document.body.clientHeight && document.documentElement.clientHeight) {
    clientHeight = Math.min(document.body.clientHeight, document.documentElement.clientHeight);
  } else {
    clientHeight = Math.max(document.body.clientHeight, document.documentElement.clientHeight);
  }
  return clientHeight;
}

var OnChangeLanguage_lvm = null;

(function() {

  var pageTranslators_lvm = [];

  OnChangeLanguage_lvm = function(e) {
    for (var i = 0; i < pageTranslators_lvm.length; i++) {
      var node = pageTranslators_lvm[i].node;
      var p = pageTranslators_lvm[i].translateProperty;
      node[p] = window.top.UNAS._(pageTranslators_lvm[i].originalText);
    }

    function lvmTranslator(id) {
      let rt_c = document.getElementById(id);
      if (!rt_c) {
        return;
      }
      var tmp_pageTranslators = window.top.UNAS.CreateNodesTranslators(rt_c);
      pageTranslators_lvm = pageTranslators_lvm.concat(tmp_pageTranslators);
      OnChangeLanguage_lvm();
    }
    window.lvmTranslator = lvmTranslator;
  };
  OnChangeLanguage_lvm();
  window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage_lvm);
  window.addEventListener("unload", function(e) {
    window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage_lvm);
  }, false);

})();
