var initData = {
  list: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: 500 //每页数量
}
var snapshot_data = [];
var snapshot_rm = [];
var send_data = [];
var rm_i = 0;
var lvmsnapshot_tasknamelist = [];
var currlvinfo = {};
var snapshot_is_mounted = 0;

function encodeHtml(str) {
  var encodedStr = "";
  if (str == "") return encodedStr;
  else {
    for (var i = 0; i < str.length; i++) {
      encodedStr += "&#" + str.substring(i, i + 1).charCodeAt().toString(10) + ";";
    }
  }
  return encodedStr;
}

function refreshSnapshots(data, count, curr) {

  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: initData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        initData.curr = obj.curr;
        let t = arrTrans(initData.limit, data);
        jQuery('#jv-pageitemV').text(initData.limit);
        jQuery('#snapshots_list').html('');
        jQuery("#jv-snapshot-selectall").prop("checked", false);
        jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled').attr('disabled', true);
        if (count <= initData.limit) {
          initData.curr = 1;
        }

        if (data.length) {
          var len = t[initData.curr - 1].length;
          for (var i = 0; i < len; i++) {
            let info = t[initData.curr - 1][i];

            var zfilesys_status = false;
            var mounted = info.mountpoint ? true : false;
            var m_h = '';

            if (snapshot_fstype == 'xfs') {
              m_h = '<span>' +
                '<a class="' + (info.mountpoint ? 'unmounticon' : 'mounticon') + '" onClick="' + (info.mountpoint ? 'lvm_submit_umount' : 'lvm_submit_mount') + '(this);" zpool="' + info.vg + '" zfilesys="' + info.lv + '" snap="' + info.name + '" title="' + '##$@lvm@$##' + (info
                  .mountpoint ? 'Unmount' : 'Mount') + '##$@lvm@$##' + '"></a>' +
                '</span>';
            }

            var tr = '<tr class="infosnapshot" mounted="'+mounted+'">' +
              '<td style="width:5%;text-align:center;">' +
              '<span class="unas_table_text"><div class="unas_checkbox"><input type="checkbox" name="snapshot_check" id="snapshot_check' + i + '" zpool="' + info.vg + '" zfilesys="' + info.lv + '" snap="' + info.name + '"' +
              '><label for="snapshot_check' + i + '"></label></div></span>' +
              '</td>' +

              '<td width="70%" align="left"><span class="unas_table_text jvc-snapshotname">' + info.lv + '</span></td>' +
              '<td width="25%" align="center"><div class="unas-flex" style="justify-content: space-evenly;;padding-right: 10px;">' +
              m_h +
              // '<span>' +
              // '<a class="cloneicon" onClick="submit_clone(this);" zpool="' + info.vg + '" zfilesys="' + info.lv + '" snap="' + info.name + '" title="' + '##$@lvm@$##Clone##$@lvm@$##' + '"></a>' +
              // '</span>' +
              '<span><a class="rollbackicon" onClick="lvm_submit_rollback(this);" zpool="' + info.vg + '" zfilesys="' + info.lv + '" snap="' + info.name + '" title="' + '##$@lvm@$##Rollback##$@lvm@$##' + '"></a>' +
              '</span>' +
              '<div>' +
              '<span class="jvc-sendingicon"><a class="sendingicon" onClick="submit_send(this);" zpool="' + info.vg + '" zfilesys="' + info.lv + '" snap="' + info.name + '" title="' + '##$@lvm@$##Send##$@lvm@$##' + '"></a>' +
              '</span><div class="cupUsageEC jvc-cupUsageEC"></div>' +
              '</div>' +
              '<span class="unas_table_text">' + '<a class="deleteicon" onClick="submit_delSnapzfilesys(this);" zpool="' + info.vg + '" zfilesys="' + info.lv + '" snap="' + info.name +
              '" oldshare="' + (zfilesys_status ? 'yes' : 'no') + '" tag="' + info.tag + '" title="' + '##$@lvm@$##Delete##$@lvm@$##' + '"></a></span></div></td></tr>';
            jQuery('#snapshots_list').append(tr);

          }
          var len_snapshot = jQuery('#snapshots_list tr').length;
          jQuery('#snapshots_list tr').each(function(i, e) {
            seteChart(jQuery(e).find('.jvc-cupUsageEC')[0], 0, '#08cea1');
          })

          jQuery('#snapshots_list tr').each(function(i, e) {
            jQuery(e).find('input[name="snapshot_check"]').on('click', function() {
              var ck_len = jQuery('input[name="snapshot_check"]:checked').length
              if (!ck_len) {
                jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled').attr('disabled', true);
              } else {
                jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content').attr('disabled', false);
              }
              if (ck_len == len_snapshot) {
                jQuery("#jv-snapshot-selectall").prop("checked", true);
              } else {
                jQuery("#jv-snapshot-selectall").prop("checked", false);
              }

              updateLvmSnapMountsBtntxt();
            })
          })


          jQuery("#snapshots_list tr:even").addClass("tr_even");
          jQuery("#snapshots_list tr:odd").addClass("tr_odd");
          jQuery('#snapshots_list tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#snapshots_list tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#snapshots_list tr:even").addClass("tr_even");
            jQuery('#snapshots_list tr:odd').addClass("tr_odd");
          });

        }

        jQuery('#jv-pageitemList').children().each(function(i, e) {
          e.onclick = function() {
            initData.limit = jQuery(e).text();
            refreshSnapshots(data, count, initData.curr);
          }
        })
        if (obj.pages >= 1 && obj.count) {
          jQuery('#jv-footerPage').show();
        } else {
          jQuery('#jv-footerPage').hide();
        }

        //首次不执行
        if (!first) {
          refreshSnapshots(data, count, initData.curr);
        }

        lvmTranslator('snapshots_list');
      }
    });
  });
  getTaskProgress();
}

function getTaskProgress() {
  clearTimeout(send_tiem_lvm);
  let data = {
    cmd: 'lv_snap_tasks',
    token: UToken
  }
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 3000000,
    success: function(result) {
      var info = result.results || {};
      var running = info.run || {};
      send_data = [];
      if (running.export) {
        for (var v in running.export) {
          if (running.export.hasOwnProperty(v)) {
            send_data.push(running.export[v]);
          }
        }
      }

      if (send_data.length) {
        jQuery('#snapshots_list tr').each(function(i, e) {
          for (var k = 0; k < send_data.length; k++) {
            var send_info = send_data[k];
            var stat = send_info.stat;
            var n = jQuery(e).find('.jvc-snapshotname').text();
            if (send_info.snapname == jQuery(e).find('.jvc-snapshotname').text()) {
              var p = 0;
              if (stat == undefined) {

              } else {
                var capacity = currlvinfo.capacity * 1024 * 1024;
                p = parseInt((stat[0] / capacity) * 100) || 0;
              }

              if (stat != undefined) {
                if (p > 100) {
                  p = 100;
                } else if (!stat.length) {
                  p = 100;
                }
              }

              jQuery(e).find('.jvc-cupUsageEC').show();
              jQuery(e).find('.jvc-sendingicon').hide();
              seteChart(jQuery(e).find('.jvc-cupUsageEC')[0], parseInt(p), '#08cea1');
              break;
            } else {
              jQuery(e).find('.jvc-cupUsageEC').hide();
              jQuery(e).find('.jvc-sendingicon').show();
            }
          }
        })
      } else {
        jQuery('.jvc-cupUsageEC').hide();
        jQuery('.jvc-sendingicon').show();
      }

      if (send_data.length) {
        send_tiem_lvm = setTimeout(function() {
          getTaskProgress();
        }, 2000);
      } else {
        clearTimeout(send_tiem_lvm);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function getSnapshotstiming() {
  showload_snapshotpage();
  let data = {
    cmd: 'lv_snap_tasks',
    token: UToken
  }
  jQuery.ajax({
    url: '/wmi/index.php',
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 3000000,
    success: function(result) {
      if (result.err != 0) {
        return;
      }
      var timing = result.results.timing || {};
      var autosnap = {};
      if (jQuery.isEmptyObject(timing)) {
        autosnap = {};
      } else {
        autosnap = timing[snapshot_zpoolname][snapshot_zfilesysname] || {};
      }

      checkSnapZfilesysname();

      if (autosnap.on) {
        jQuery('#create_lvmsnaptask_schedule').prop('checked', true);
        jQuery('#lvm_snap_frequent').prop('disabled', false);
        jQuery('#lvm_snap_hourly').prop('disabled', false);
        jQuery('#lvm_snap_daily').prop('disabled', false);
        jQuery('#lvm_snap_weekly').prop('disabled', false);
        jQuery('#lvm_snap_monthly').prop('disabled', false);
        jQuery('#snap_set_copies').prop('disabled', false);
        jQuery('#snap_set_keep_text').prop('disabled', false);

      } else {
        jQuery('#create_lvmsnaptask_schedule').prop('checked', false);
        jQuery('#lvm_snap_frequent').prop('disabled', true);
        jQuery('#lvm_snap_hourly').prop('disabled', true);
        jQuery('#lvm_snap_daily').prop('disabled', true);
        jQuery('#lvm_snap_weekly').prop('disabled', true);
        jQuery('#lvm_snap_monthly').prop('disabled', true);
        jQuery('#snap_set_copies').prop('disabled', true);
        jQuery('#snap_set_keep_text').prop('disabled', true);
      }

      if (autosnap['frequently-on']) {
        jQuery('#lvm_snap_frequent').prop('checked', true);
        jQuery('#lvm_snap_frequent_copies').prop('disabled', false);
      } else {
        jQuery('#lvm_snap_frequent').prop('checked', false);
        jQuery('#lvm_snap_frequent_copies').prop('disabled', true);
      }
      if (autosnap['hourly-on']) {
        jQuery('#lvm_snap_hourly').prop('checked', true);
        jQuery('#lvm_snap_hourly_copies').prop('disabled', false);
      } else {
        jQuery('#lvm_snap_hourly').prop('checked', false);
        jQuery('#lvm_snap_hourly_copies').prop('disabled', true);
      }
      if (autosnap['daily-on']) {
        jQuery('#lvm_snap_daily').prop('checked', true);
        jQuery('#lvm_snap_daily_copies').prop('disabled', false);
      } else {
        jQuery('#lvm_snap_daily').prop('checked', false);
        jQuery('#lvm_snap_daily_copies').prop('disabled', true);
      }
      if (autosnap['weekly-on']) {
        jQuery('#lvm_snap_weekly').prop('checked', true);
        jQuery('#lvm_snap_weekly_copies').prop('disabled', false);
      } else {
        jQuery('#lvm_snap_weekly').prop('checked', false);
        jQuery('#lvm_snap_weekly_copies').prop('disabled', true);
      }
      if (autosnap['monthly-on']) {
        jQuery('#lvm_snap_monthly').prop('checked', true);
        jQuery('#lvm_snap_monthly_copies').prop('disabled', false);
      } else {
        jQuery('#lvm_snap_monthly').prop('checked', false);
        jQuery('#lvm_snap_monthly_copies').prop('disabled', true);
      }

      if (autosnap.on) {
        jQuery('#lvm_snap_frequent_copies').val(autosnap.frequently);
        jQuery('#lvm_snap_hourly_copies').val(autosnap.hourly);
        jQuery('#lvm_snap_daily_copies').val(autosnap.daily);
        jQuery('#lvm_snap_weekly_copies').val(autosnap.weekly);
        jQuery('#lvm_snap_monthly_copies').val(autosnap.monthly);
      } else {
        jQuery('#lvm_snap_frequent_copies').val('15');
        jQuery('#lvm_snap_hourly_copies').val('24');
        jQuery('#lvm_snap_daily_copies').val('7');
        jQuery('#lvm_snap_weekly_copies').val('4');
        jQuery('#lvm_snap_monthly_copies').val('12');
      }
    },
    complete: function(x) {
      hideload_snapshotpage();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);

    }
  });
}

function checkSnapZfilesysname() {
  var state = 1;
  var zfilesysname = "";
  var zfilesysname = jQuery.trim(jQuery('#newsnapshot_name').val()).toLowerCase();
  var zpoolname = "";
  var zpoolname = jQuery.trim(jQuery('#snapshot_zpoolname').html());

  for (var i = 0; i < snapshot_data.length; i++) {
    if (snapshot_data[i].name == zfilesysname) {
      state = 0;
    }
  }

  if (state) {
    jQuery('#newsnapshot_name').attr('class', 'unas_input');
    jQuery("#newsnapshot_name").attr('title', '');

  } else {
    jQuery('#newsnapshot_name').attr('class', 'unas_input_error');
    jQuery("#newsnapshot_name").attr('title', UNAS._('##$@lvm@$##Volume name is already in use##$@lvm@$##'));
  }

}

function submit_addSnapshot_lvm() {
  var snap = jQuery.trim(jQuery('#newsnapshot_name').val()).toLowerCase();
  if (jQuery.trim(snap) == "") {
    return false;
  }
  var zfilesysname = jQuery('#snapshot_zfilesysname').html();
  var zpoolname = jQuery('#snapshot_zpoolname').html();
  if (jQuery("#newsnapshot_name").attr("class") != "unas_input_error") {

    let data = {
      cmd: 'lv_snap_create',
      token: UToken,
      params: {
        "vg": zpoolname,
        "lv": zfilesysname,
        "snapname": snap,
        "size": "1G"
      }
    }
    showload_snapshotpage();
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 3000000,
      success: function(data) {
        if (data.err == 0) {
          getlvmalloadinfo();
          jQuery('#newsnapshot_name').val('');
        }else {
          if (errcode[data.err]) {
            alert(errcode[data.err]);
          }else {
            alert(data.errmsg);
          }
        }
      },
      complete: function() {
        hideload_snapshotpage();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  }
}

function replication_delete(e) {
  var name = jQuery(e).attr('name');
  var data = {
    cmd: 'lvm_snapshot_replicate_rm',
    params: {
      name: name
    }
  }
  jQuery.ajax({
    url: "/apps/lvm/includes/index.php",
    type: "POST",
    async: true,
    timeout: 30000,
    data: JSON.encode(data),
    success: function(data) {
      if (data == "2") {
        jQuery("#mountzfilesys_checkkey").attr('style', 'display:');
        jQuery("#mountzfilesys_checkkey").attr('title', UNAS._('##$@lvm@$##The password is invalid.##$@lvm@$##'));
      }
      // getSnapshotsInfo();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });

}

function submit_editSnapzfilesys(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery(e).attr('zpool');
  var zfilesys = jQuery(e).attr('zfilesys');
  var oldshare = jQuery(e).attr('oldshare');
  var share = jQuery('#snapshare' + zpool + '-' + snap_name).val();
  var tag = jQuery(e).attr('tag');
  var crypt = jQuery('#snapshot_zfilesyscrypt').val();
  if (share != oldshare) {
    jQuery.ajax({
      url: "/apps/lvm/include/lvm_fun.php",
      type: "POST",
      async: true,
      data: {
        snap_name: snap_name,
        zpool: zpool,
        zfilesys: zfilesys,
        share: share,
        oldshare: oldshare,
        tag: tag,
        crypt: crypt,
        action: "editsnapshot"
      },
      timeout: 30000,
      success: function(data) {
        if (data == "2") {
          jQuery("#mountzfilesys_checkkey").attr('style', 'display:');
          jQuery("#mountzfilesys_checkkey").attr('title', UNAS._('##$@lvm@$##The password is invalid.##$@lvm@$##'));
        }
        // getSnapshotsInfo();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  }
}

function submit_delSnapzfilesys(e) {
  th_alertWindowFn({
    tips: "Are you sure to delete the snapshot?"
  }, function() {
    lvm_snapshot_rm(e);
  })
}

function lvm_snapshot_rm(e, f) {
  var snapshots = [];
  var zpool = jQuery('#snapshot_zpoolname').text();

  if (jQuery.isArray(e)) {
    for (var i = 0; i < e.length; i++) {
      var name = jQuery(e[i]).attr('snap');
      snapshots.push([zpool, name]);
    }
  } else {
    var name = jQuery(e).attr('snap');
    snapshots = [
      [zpool, name]
    ];
  }

  let data = {
    cmd: 'lv_snap_remove',
    token: UToken,
    params: {
      snaps: snapshots
    }
  }
  showload_snapshotpage();
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 300000,
    success: function(data) {
      getlvmalloadinfo();
    },
    complete: function() {
      hideload_snapshotpage();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function snapshot_deleteS() {

  th_alertWindowFn({
    tips: "Are you sure to delete the snapshot?"
  }, function() {
    snapshot_rm = [];
    jQuery('#snapshots_list tr').each(function(i, e) {
      if (jQuery(e).find('input[type="checkbox"]').prop("checked")) {
        var that = jQuery(e).find('input[type="checkbox"]');
        snapshot_rm.push(that);
      }
    })
    lvm_snapshot_rm(snapshot_rm, 1);
  })

}

// 回滚
function lvm_submit_rollback(e) {
  var mounted = jQuery(e).closest('tr.infosnapshot').attr('mounted');
  if (snapshot_is_mounted) {
    tipBox(UNAS._("To roll back, please uninstall all snapshots first"));
    return;
  }

  th_alertWindowFn({
    tips: "Are you sure to rollback the snapshot? Current data will be lost!"
  }, function() {
    var snap_name = jQuery(e).attr('snap');
    var zpool = jQuery('#snapshot_zpoolname').html();
    let data = {
      cmd: 'lv_snap_merge',
      token: UToken,
      params: {
        snapname: snap_name,
        vg: zpool
      }
    }
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(data) {
        getlvmalloadinfo();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })

}
// 挂载
function lvm_submit_mount(e, f) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery('#snapshot_zpoolname').html();
  var zfilesys = jQuery('#snapshot_zfilesysname').html();
  showload_snapshotpage();
  let data = {
    cmd: 'lv_snap_mount',
    token: UToken,
    params: {
      snapname: snap_name,
      vg: zpool
    }
  }
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {},
    complete : function(){
      if (f == undefined && !f) {
        getlvmalloadinfo();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function snapshot_mountS() {
  var mounted = jQuery('#jv-mounts-bnt').attr('mounted');
  var k = 0;
  jQuery('#snapshots_list tr').each(function(i, e) {
    if (jQuery(e).find('input[type="checkbox"]').prop("checked")) {
      var that = jQuery(e).find('input[type="checkbox"]');
      var md = jQuery(e).attr('mounted');
      if (mounted == 'false') {
        if (mounted == md) {
          lvm_submit_mount(that, 1);
        }
      }else {
        lvm_submit_umount(that, 1);
      }

      k++;
    }
  })
  if (k == jQuery('#snapshots_list input[type="checkbox"]:checked').length) {
    getlvmalloadinfo();
  }
}
// 卸载
function lvm_submit_umount(e, f) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery('#snapshot_zpoolname').html();
  let data = {
    cmd: 'lvm_lv_umount',
    token: UToken,
    params: {
      lv: snap_name,
      vg: zpool
    }
  }
  showload_snapshotpage();
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {},
    complete : function(){
      if (f == undefined && !f) {
        getlvmalloadinfo();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function submit_clone(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery('#snapshot_zpoolname').html();
  var zfilesys = jQuery('#snapshot_zfilesysname').html();
  var share = jQuery(e).attr('oldshare');
  var tag = jQuery(e).attr('tag');
  var crypt = jQuery('#snapshot_zfilesyscrypt').val();
  let data = {
    cmd: 'lvm_snapshot_clone',
    params: {
      name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    }
  }
  jQuery.ajax({
    url: "/apps/lvm/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: 'application/json',
    data: JSON.encode(data),
    timeout: 30000,
    success: function(data) {
      // getSnapshotsInfo();
      var w = window.top.UNAS.GetWindow('SnapshotWindow');
      w.ProcessSnapshot();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function submit_send(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery(e).attr('zpool');
  var zfilesys = jQuery(e).attr('zfilesys');
  var sendSnapshotWindow = new MUI.Modal({
    id: 'jv-sendSnapshotWindow',
    title: window.top.UNAS._('##$@lvm@$##Send Snapshot##$@lvm@$##'),
    modal: true,
    width: 550,
    height: 380,
    data: {
      snap_name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    },
    modalOverlayClose: false,
    contentURL: '/apps/lvm/snapshot/send_snapshot.html?v=6.1.13',
  });
  sendSnapshotWindow.callBack = function() {
    getTaskProgress();
  }
}

function snapshot_sendS(e) {
  var sendSnapshotWindow = new MUI.Modal({
    id: 'jv-sendSnapshotWindow',
    title: window.top.UNAS._('##$@lvm@$##Send Snapshot##$@lvm@$##'),
    modal: true,
    width: 550,
    height: 380,
    data: {
      type: 'list'
    },
    modalOverlayClose: false,
    contentURL: '/apps/lvm/snapshot/send_snapshot.html?v=6.1.13',
  });
}


function AutoSnapClick(id) {
  if (jQuery("#" + id).is(':checked')) {
    jQuery("#" + id + "_copies").prop('disabled', false); //show
  } else {
    jQuery("#" + id + "_copies").prop('disabled', true); //hide
  }
  jQuery("#lvm_autosnap_submit").attr("class", "unas_button_sub");
}

function submit_AutoSnap_lvm() {
  showload_snapshotpage();
  var autosnap = jQuery("#create_lvmsnaptask_schedule").prop('checked');
  var frequently_on = jQuery("#lvm_snap_frequent").prop('checked');
  var daily_on = jQuery("#lvm_snap_daily").prop('checked');
  var hourly_on = jQuery("#lvm_snap_hourly").prop('checked');
  var weekly_on = jQuery("#lvm_snap_weekly").prop('checked');
  var monthly_on = jQuery("#lvm_snap_monthly").prop('checked');

  var frequently = parseInt(jQuery("#lvm_snap_frequent_copies").val());
  var hourly = parseInt(jQuery("#lvm_snap_hourly_copies").val());
  var daily = parseInt(jQuery("#lvm_snap_daily_copies").val());
  var weekly = parseInt(jQuery("#lvm_snap_weekly_copies").val());
  var monthly = parseInt(jQuery("#lvm_snap_monthly_copies").val());

  var zpool = jQuery('#snapshot_zpoolname').html();
  var zfilesys = jQuery('#snapshot_zfilesysname').html();

  if (!autosnap) {
    frequently_on = false;
    daily_on = false;
    hourly_on = false;
    weekly_on = false;
    monthly_on = false;
  }

  timing = {
    "on" : autosnap,
    "frequently": frequently,
    "hourly": hourly,
    "daily": daily,
    "weekly": weekly,
    "monthly": monthly,
    "frequently-on" : frequently_on,
    "hourly-on" : hourly_on,
    "daily-on" : daily_on,
    "weekly-on" : weekly_on,
    "monthly-on" : monthly_on
  }

  let data = {
    "cmd": "lv_snap_autosnap_set",
    token: UToken,
    "params": {
      "vg": zpool,
      "lv": zfilesys,
      "timing": timing
    }
  }

  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 300000,
    success: function(data) {
      getSnapshotstiming();
    },
    complete: function() {
      hideload_snapshotpage();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });

}

function addTimeZero_lvmsnapshot(num) {
  return num >= 10 ? num : '0' + num;
}

function createlvmTaskWin(info = '', type = '') {
  var title = UNAS._('##$@lvm@$##Create send task##$@lvm@$##');
  type && (title = UNAS._('##$@lvm@$##Edit Task##$@lvm@$##'));
  var createsendtaskWin = new MUI.Modal({
    id: 'jv-createsendtaskWindow',
    title: title,
    modal: true,
    modalOverlayClose: false,
    width: 800,
    height: 550,
    sendtask: {
      info: info,
      type: type
    },
    onClose: function() {
      send_reqstatus = 0;
    },
    contentURL: '/apps/lvm/snapshot/lvm_sendtask.html?v=6.1.13&'
  });
}

// 获取快照列表
function getlvmalloadinfo() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      data: JSON.encode({
        cmd: 'lvm_alload',
        token: UToken
      }),
      timeout: TIMEOUT,
      dataType: "json",
      success: function(result) {
        var vgs = result.results.vgs || {};
        snapshot_data = [];
        snapshot_is_mounted = 0;
        for (var v in vgs[snapshot_zpoolname].lvs) {
          if (vgs[snapshot_zpoolname].lvs.hasOwnProperty(v)) {
            var tp = vgs[snapshot_zpoolname].lvs[v];
            tp['name'] = v;
            if (tp.ancestors == snapshot_zfilesysname && tp.snap) {
              snapshot_data.push(tp);
              if (tp.mountpoint) {
                snapshot_is_mounted = 1;
              }
            }
          }
        }
        refreshSnapshots(snapshot_data, snapshot_data.length, initData.curr);
      },
      complete : function(){
        hideload_snapshotpage();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })

}

function updateLvmSnapMountsBtntxt(){
  var dom = jQuery('#snapshots_list input[type="checkbox"]:checked');
  var m = [], f = 0;
  for (var i = 0; i < dom.length; i++) {
    var e = dom[i];
    var mounted = jQuery(e).closest('tr.infosnapshot').attr('mounted');
    m.push(mounted);
  }

  f = m.indexOf('false') > -1 ? 0 : 1;

  if (f && dom.length) {
    jQuery('#jv-mounts-bnt').html(UNAS._('##$@lvm@$##Unmount##$@lvm@$##')).attr("mounted", "true");
  }else {
    jQuery('#jv-mounts-bnt').html(UNAS._('##$@lvm@$##Mount##$@lvm@$##')).attr("mounted", "false");
  }
}

(function() {

  var today = new Date();
  var date = today.getFullYear() + ('0' + (today.getMonth() + 1)).slice(-2) + ('0' + today.getDate()).slice(-2);
  var time = ('0' + today.getHours()).slice(-2) + ('0' + today.getMinutes()).slice(-2) + ('0' + today.getSeconds()).slice(-2);
  var dateTime = date + '_' + time;

  jQuery('#newsnapshot_name').val(dateTime);

  jQuery("#jv-replications-table-content, #jv-snapshots_list_table_content").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  if (snapshot_fstype == 'xfs') {
    jQuery('#jv-mounts-bnt').show();
  }else {
    jQuery('#jv-mounts-bnt').hide();
  }

  getlvmalloadinfo();

  jQuery('div[lvmitemtabid]').click(function() {
    var id = jQuery(this).attr('lvmitemtabid');
    jQuery('#lvm_manager_general_tab').attr('class', 'unas_tab');
    jQuery('#lvm_manager_autosnap_tab').attr('class', 'unas_tab');
    jQuery('#lvm_manager_expand_tab').attr('class', 'unas_tab');
    jQuery('#lvm_manager_advanced_tab').attr('class', 'unas_tab');
    jQuery(this).attr('class', 'unas_tab_sel');

    jQuery('#lvm_manager_lvm_container').attr('style', 'display:none');
    jQuery('#lvm_snapshot_advanced_container').attr('style', 'display:none');
    jQuery('#lvm_snapshot_general_container').attr('style', 'display:none');
    jQuery('#lvm_snapshot_snap_container').attr('style', 'display:none');
    jQuery('#lvm_snapshot_replication_container').attr('style', 'display:none');
    jQuery('#' + id).attr('style', 'display:block');
    if (id == "lvm_snapshot_replication_container") {
      lvmsnapshot_mission_alload();
    }
  });
  jQuery('#create_lvmsnaptask_schedule').click(function() {
    if (jQuery('#create_lvmsnaptask_schedule').prop('checked') == true) {
      jQuery('#lvm_snap_frequent').prop('disabled', false);
      jQuery('#lvm_snap_hourly').prop('disabled', false);
      jQuery('#lvm_snap_daily').prop('disabled', false);
      jQuery('#lvm_snap_weekly').prop('disabled', false);
      jQuery('#lvm_snap_monthly').prop('disabled', false);
      jQuery('#snap_set_copies').prop('disabled', false);
      jQuery('#snap_set_keep_text').prop('disabled', false);

      jQuery('#lvm_snap_frequent_copies').prop('disabled', false);
      jQuery('#lvm_snap_hourly_copies').prop('disabled', false);
      jQuery('#lvm_snap_daily_copies').prop('disabled', false);
      jQuery('#lvm_snap_weekly_copies').prop('disabled', false);
      jQuery('#lvm_snap_monthly_copies').prop('disabled', false);
      jQuery('#snap_set_copies_copies').prop('disabled', false);

    } else {
      jQuery('#lvm_snap_frequent').prop('disabled', true);
      jQuery('#lvm_snap_hourly').prop('disabled', true);
      jQuery('#lvm_snap_weekly').prop('disabled', true);
      jQuery('#lvm_snap_daily').prop('disabled', true);
      jQuery('#lvm_snap_monthly').prop('disabled', true);
      jQuery('#snap_set_copies').prop('disabled', true);
      jQuery('#snap_set_keep_text').prop('disabled', true);


      jQuery('#lvm_snap_frequent_copies').prop('disabled', true);
      jQuery('#lvm_snap_hourly_copies').prop('disabled', true);
      jQuery('#lvm_snap_weekly_copies').prop('disabled', true);
      jQuery('#lvm_snap_daily_copies').prop('disabled', true);
      jQuery('#lvm_snap_monthly_copies').prop('disabled', true);
      jQuery('#snap_set_copies_copies').prop('disabled', true);
    }
    jQuery("#lvm_autosnap_submit").attr("class", "unas_button_sub");
  });

  jQuery("#jv-snapshot-selectall").click(function() {
    if (!jQuery('#snapshots_list tr').length) {
      return;
    }
    if (jQuery("#jv-snapshot-selectall").prop("checked")) {
      jQuery("input[name='snapshot_check']").prop("checked", true);
      jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content').attr('disabled', false);
    } else {
      jQuery("input[name='snapshot_check']").prop("checked", false);
      jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled').attr('disabled', true);
    }
    updateLvmSnapMountsBtntxt();
  });

  getSnapshotstiming();

})();
