var TIMEOUT = 1200000;
var vgfree_size_g = 0;
var pools = {};
var send_tiem_lvm = null;
var time_created = null;
var vg_list = {};

function lock_exists() {
  jQuery('#lvm_manager_waiting_content').attr("style", "display: block");
  jQuery('#lvm_manager_waiting_logo').attr("style", "display: block");
  return new Promise(function(resolve, reject) {
    var t = null;
    jQuery.ajax({
      url: "/apps/lvm/include/lvm_fun.php",
      // url: "/wmi/index.php",
      type: "POST",
      async: true,
      data: {
        "action": "isCreating"
      },
      // data: JSON.stringify({
      // 	"token": UToken,
      // 	"cmd" : 'lv_created'
      // }),
      dataType: 'json',
      success: function(data) {
        if (data.err == 'ERR_SUCCEED') {
          t = setTimeout(function() {
            lock_exists();
          }, 1000);
        } else {
          clearTimeout(t);
          jQuery('#lvm_manager_waiting_content').attr("style", "display:none");
          jQuery('#lvm_manager_waiting_logo').attr("style", "display:none");
        }
      },
      complete: function(XMLHttpRequest, status) {

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })
}


function updata_created(vg, lv){
  jQuery.ajax({
    //url: "/apps/lvm/includes/index.php",
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "token": UToken,
      "cmd" : 'lv_created',
      "params": {
        "vg": vg,
        "lv": lv,
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    timeout: 60000000,
    success: function(data) {
      // console.log(data);
      var that = this;
      if (data.err !=0 ) {
        time_created = setTimeout(function(){
          jQuery.ajax(that);
          jQuery('#jv-lv'+lv).find('.lvd').hide();
          jQuery('#jv-lv'+lv).find('.createing').show();
        }, 1000);

        jQuery('#list_volumegroup').css('cursor', 'default');
        jQuery('#list_volumegroup a').addClass('deletevg_hover_disable');

      }else {
        clearTimeout(time_created);
        jQuery('#jv-lv'+lv).find('.lvd').show();
        jQuery('#jv-lv'+lv).find('.createing').hide();
        jQuery('#list_volumegroup').css('cursor', 'auto');
        jQuery('#list_volumegroup a').removeClass('deletevg_hover_disable');
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
    }
  });
}

function getVGsInfo(sel_vg, creating) {
  if (creating != 0) {
    jQuery('#lvm_manager_waiting_content').attr("style", "display: block");
    jQuery('#lvm_manager_waiting_logo').attr("style", "display: block");
  }
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      // url: "/apps/lvm/include/lvm_fun.php",
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      // data: { "action": "get_vgsinfo" },
      data: JSON.encode({
        cmd: 'lvm_alload',
        token: UToken
      }),
      timeout: TIMEOUT,
      dataType: "json",
      success: function(result) {
        // console.log(result);
        var data = [];
        vg_list = result.results.vgs || {};
        pools = result.results.pools || {};
        for (var variable in result.results.vgs) {
          if (result.results.vgs.hasOwnProperty(variable)) {
            data.push(result.results.vgs[variable])
          }
        }

        jQuery('#list_volumegroup').html('');

        for (var i = 0; i < data.length; i++) {
          var vg_size = formSize((data[i].size || 0) * 1024);
          var vgfree_size = formSize((data[i].free || 0) * 1024);
          data[i].name = data[i].name || data[i].vg;
          var vg_cache_size = "";
          var vg_cache_free_size = "";
          var cachedata = null;
          if (data[i].cache) {
            vg_cache_size = data[i].cache.size !== undefined ? formSize(data[i].cache.size * 1024) : "";
            vg_cache_free_size = data[i].cache.free !== undefined ? formSize(data[i].cache.free * 1024) : "";
            cachedata = JSON.stringify(data[i].cache);
          }

          var lvs = [];

          if (Array.isArray(data[i].lvs)) {
            lvs = data[i].lvs;
          } else {
            for (var lvsV in data[i].lvs) {
              if (data[i].lvs.hasOwnProperty(lvsV)) {
                lvs.push(data[i].lvs[lvsV]);
              }
            }
            data[i].lvs = lvs;
          }

          //
          var is_open = false;
          if ((i == 0) && (sel_vg == "")) {
            is_open = true;
          } else if (sel_vg == data[i].name) {
            is_open = true;
          }
          if (vg_cache_free_size == "" || vg_cache_size == "") {
            var vg_top = '<dt class="' + ((is_open) ? "lvm_open" : "lvm_close") + '" id="vg_dt_' + i + '">' +
              '<div class="open_button">' +
              '<a><span class="' + ((is_open) ? "close_img" : "open_img") + '" onclick="openCloseVgWindow(this,' + i + ');"></span></a>' +
              '</div>' +
              '<div class="date ' + (data[i].lvs.length > 0 ? "deletevg_hover_disable" : "deletevg_hover") + '">' +
              '<a ' + (data[i].lvs.length > 0 ? "" : ('onClick="DeleteVgWindowFun(' + "'" + data[i].name + "'" + ')"')) + '><span class="' + (data[i].lvs.length > 0 ? "delvg_button_img_disable" : "delvg_button_img") + '"></span><span>' + '##$@lvm@$##Delete VG##$@lvm@$##' + '</span></a>' +
              '</div>' +
              '<div class="date' + (data[i].free > 32 ? "" : " createvg_hover_disable") + '">' +
              '<a title="' + (data[i].free < 33 ? '##$@lvm@$##No Free Space##$@lvm@$##' : "") + '" ' + (data[i].free < 33 ? "" : ('onClick="CreateLvWindowFun(' + "'" + data[i].name + "','" + data[i].size + "','" + data[i].free + "'" + ')"')) + '><span class="' + (data[i].free > 32 ? "createlv_button_img" : "createlv_button_img_disable") + '"></span><span>' + '##$@lvm@$##Create Volume##$@lvm@$##' + '</span></a>' +
              '</div>' +
              '<div class="date">' +
              '<a onClick="EditVgWindowFun(' + "'" + (data[i].name || '--') + "','" + vg_size + "','" + data[i].free + "'" + ')" ><span class="editvg_button_img"></span><span>' + '##$@lvm@$##Edit##$@lvm@$##' + '</span></a>' +
              '</div>' +
              '<div class="title"><span style="margin-right:5px;">' + '##$@lvm@$##Volume Group##$@lvm@$##' + '</span><span>' + (data[i].name || '--') + '</span><span class="size"> ( ' + vg_size + ' / ' + vgfree_size + ' </span><span class="size">' + '##$@lvm@$##Unallocated Storage##$@lvm@$## )' + '</span></div>' +
              '</dt>';
          } else {
            var vg_top = '<dt class="' + ((is_open) ? "lvm_open" : "lvm_close") + '" id="vg_dt_' + i + '">' +
              '<div class="open_button">' +
              '<a><span class="' + ((is_open) ? "close_img" : "open_img") + '" onclick="openCloseVgWindow(this,' + i + ');"></span></a>' +
              '</div>' +
              '<div class="date ' + (data[i].lvs.length > 0 ? "deletevg_hover_disable" : "deletevg_hover") + '">' +
              '<a ' + (data[i].lvs.length > 0 ? "" : ('onClick="DeleteVgWindowFun(' + "'" + (data[i].name || '--') + "'" + ')"')) + '><span class="' + (data[i].lvs.length > 0 ? "delvg_button_img_disable" : "delvg_button_img") + '"></span><span>' + '##$@lvm@$##Delete VG##$@lvm@$##' + '</span></a>' +
              '</div>' +
              '<div class="date' + (data[i].free > 32 ? "" : " createvg_hover_disable") + '">' +
              '<a title="' + (data[i].free < 33 ? '##$@lvm@$##No Free Space##$@lvm@$##' : "") + '" ' + (data[i].free < 33 ? "" : ('onClick="CreateLvWindowFun(' + "'" + (data[i].name || '--') + "','" + data[i].size + "','" + data[i].free + "'" + ')"')) + '><span class="' + (data[i].free > 32 ? "createlv_button_img" : "createlv_button_img_disable") + '"></span><span>' + '##$@lvm@$##Create Volume##$@lvm@$##' + '</span></a>' +
              '</div>' +
              '<div class="date">' +
              '<a onClick="EditVgWindowFun(' + "'" + (data[i].name || '--') + "','" + vg_size + "','" + data[i].free + "'" + ')" ><span class="editvg_button_img"></span><span>' + '##$@lvm@$##Edit##$@lvm@$##' + '</span></a>' +
              '</div>' +
              '<div class="title"><span style="margin-right:5px;">' + '##$@lvm@$##Volume Group##$@lvm@$##' + '</span><span>' + (data[i].name || '--') + '</span><span class="size"> ( ' + vg_size + ' / ' + vgfree_size + ' </span><span class="size">' + '##$@lvm@$##Unallocated Storage##$@lvm@$##' + '</span><span class="size">  ' + vg_cache_size + ' / ' + vg_cache_free_size + ' ##$@lvm@$##Unallocated Cache##$@lvm@$## )</span> </div>' +
              '</dt>';
          }


          var vglv_cont = "";
          var lv_cont_act_sec = "";
          jQuery.each(data[i].lvs, function(key, lv) {
            if (lv.snap) {
              return;
            }
            var lv_cont_head = "";
            var lv_cont_percent = "";
            var lv_cont_df = "";
            var lv_cont_act = "";
            var lv_cont_creating = "";
            var zt = "<span>&nbsp;</span>";
            if (lv.fstype == "lun") {
              lv_cont_head = '<h3 class="unas-flex"><a class="unas_table_text" title="' + lv.lv + '"><span>' + ((lv.type == "thin") ? "##$@lvm@$##Thin LUN Device:##$@lvm@$##" : "##$@lvm@$##LUN Device:##$@lvm@$##") + '</span> ' + lv.lv + '</a></h3>';
            } else {
              lv_cont_head = '<h3 class="unas-flex"><a class="unas_table_text" title="' + lv.lv + '"><span>' + ((lv.type == "thin") ? "##$@lvm@$##Thin Volume:##$@lvm@$##" : "##$@lvm@$##Volume:##$@lvm@$##") + '</span>' + lv.lv + ((lv.crypt) ? '<span>(##$@lvm@$##Encrypted##$@lvm@$##)</span>' : '') + '</a></h3>';
            }
            // if( (lv.attr == "1") && (lv.fstype !="lun") && ((lv.crypt) || ((lv.crypt) && (lv.mounted == 1))) )
            if ((lv.capacity || lv.size) && lv.mountpoint) {
              // var use = (((lv.size / lv.capacity) * 100).toFixed(2) || 0) + '%';
              var use = lv.fsrate + '%';
              var fsrate = lv.fsrate > 90 ? 'fsrate-warn' : 'fsrate';

              lv_cont_percent = '<div class="volume_percentage">' +
                '<ul>' +
                '<li class="percent_box" id="percentagebox' + lv.vg + "-" + lv.lv + '" style="" title="' + use + '">' +
                '<span class="' + fsrate + '" style="width:' + use + ';"></span>' +
                '</li><li></li></ul>' +
                '</div>';
            } else {
              lv_cont_percent = '<div class="volume_percentage">' +
                '<ul>' +
                '<li class="percent_box_null" id="percentagebox' + lv.vg + "-" + lv.lv + '" title="">' +
                '<span class="fsrate-warn" style="width:185px;"></span>' +
                '</li><li></li></ul>' +
                '</div>';
            }

            var lv_size = formSize(lv.capacity * 1024 || 0);
            if ((!lv.mountpoint) && (lv.fstype != "lun")) {
              zt = '<span class="zt-0">' + '##$@lvm@$##Unmounted##$@lvm@$##' + '</span>';
              lv_cont_df = '<div class="lv_cont_df jvc-child-' + lv.lv + '"><span id="lvinfo_avail' + lv.vg + "-" + lv.lv + '"></span>&nbsp;<span>' + '##$@lvm@$##Total##$@lvm@$##' + ' </span>' + '<span>' + lv_size + '</span></div>';
            } else if (lv.fstype == "lun") {
              lv_cont_df = '<div class="lv_cont_df jvc-child-' + lv.lv + '"><span>' + '##$@lvm@$##Size##$@lvm@$##' + '</span>' + ':' + '<span>' + lv_size + '</span></div>';
            } else if ((lv.mountpoint)) {
              lv_cont_df = '<div class="lv_cont_df jvc-child-' + lv.lv + '"><span id="lvinfo_availsize' + lv.vg + "-" + lv.lv + '">' + formSize(lv.fsfree * 1024) + '</span>' + '<span id="lvinfo_avail' + lv.vg + "-" + lv.lv + '"> ' + '##$@lvm@$##available##$@lvm@$##' + '</span>,&nbsp;<span>' + '##$@lvm@$##Total##$@lvm@$##' + ' </span>' + '<span>' + lv_size + '</span></div>';
            }
            lv_cont_act = '<div class="lvd lv_cont_df volume_action jvc-child-' + lv.lv + '"><p class="unas-flex"><a class="zPproperty" cachedata=' + cachedata + ' onClick="EditLvWindowFun(' + "'" + lv.vg + "','" + lv.lv + "','" + (data[i].free) + "'" + ')" title="' + '##$@lvm@$##View and Edit Volume Property##$@lvm@$##' + '" >' + '##$@lvm@$##Property##$@lvm@$##' + '</a>';

            if (lv.fstype != "lun") {
              lv_cont_act += '<a class="zfgx"></a>';
              if (lv.mountpoint) {
                lv_cont_act += '<a class="zPsnapshot" onclick="lvmSnapshotWindowFun('+"'"+lv.vg + "','" + lv.lv+"','"+ lv.fstype+"'"+');">' + '##$@lvm@$##Snapshot##$@lvm@$##' + '</a>';
                lv_cont_act += '<a class="zfgx"></a>';
                lv_cont_act += '<a id="mountlv' + lv.vg + '-' + lv.lv + '" onClick="mountLv(' + "'" + lv.vg + "','" + lv.lv + "','" + lv.crypt + "'" + ')" class="' + ((lv.mountpoint) ? "umount" : "mount") + '">' + ((lv.mountpoint) ? "##$@lvm@$##Unmount##$@lvm@$##" : "##$@lvm@$##Mount##$@lvm@$##") + '</a>';
                zt = "<span class='zt-1'>##$@lvm@$##Mounted##$@lvm@$##</span>";
              } else {
                lv_cont_act += '<a id="mountlv' + lv.vg + '-' + lv.lv + '" onClick="mountLv(' + "'" + lv.vg + "','" + lv.lv + "','" + lv.crypt + "'" + ')" class="' + ((lv.mountpoint) ? "umount" : "mount") + '">' + ((lv.mountpoint) ? "##$@lvm@$##Unmount##$@lvm@$##" : "##$@lvm@$##Mount##$@lvm@$##") + '</a>';
                lv_cont_act += '<a class="zfgx"></a>';
                lv_cont_act +='<a id="deletelv' + lv.vg + '-' + lv.lv + '" class="zDelete' + (((lv.mountpoint)) ? "lv_delete_none" : "") + '" type="' + lv.type + '" onClick="deleteLv(' + "'" + lv.vg + "','" + lv.lv + "','" + lv.crypt + "'" + ');">##$@lvm@$##Delete##$@lvm@$##</a>';
              }

            } else if (lv.fstype == "lun") {
              lv_cont_act += '<a class="zfgx"></a>';
              lv_cont_act += '<a class="zPsnapshot" onclick="lvmSnapshotWindowFun('+"'"+lv.vg + "','" + lv.lv+"','"+ lv.fstype+"'"+');">' + '##$@lvm@$##Snapshot##$@lvm@$##' + '</a>';
              lv_cont_act += '<a class="zfgx"></a>';
              lv_cont_act += '<a id="deletelv' + lv.vg + '-' + lv.lv + '" class="zDelete' + (((lv.attr == "1")) ? "lv_delete_none" : "") + '"  type="' + lv.type + '" onClick="deleteLv(' + "'" + lv.vg + "','" + lv.lv + "'" + ');">';

              if (lv.attr == "1") {
                lv_cont_act += "##$@lvm@$##Used##$@lvm@$##";
              } else {
                lv_cont_act += "##$@lvm@$##Delete##$@lvm@$##";
              }

            }
            lv_cont_act += '</div>';

            vglv_cont += '<dl id=jv-lv' + lv.lv + '>'+lv_cont_head +
            '<div class="' + ((lv.fstype != "lun") ? "samp1" : "samp2") + '">' +
              '<div class="">' +
              lv_cont_df +
              '</div>' +
              lv_cont_percent +
              zt+
              '</div>' +
              lv_cont_act +
              '<div class="createing"><span>Createing</span><span>...</span></div>' +
              '</dl>';
          });
          var lv_content = '<dd id="vg_dd_' + i + '" name="vg-' + data[i].name + '" style="display:' + (is_open ? "block" : "none") + '"><div class="content"><ul style="margin-right:-20px;"><li>' +
            vglv_cont +
            '<div class="clearvgcontent"></div>' +
            '</li></ul></div></dd>';;
          var vg_info = vg_top + lv_content;
          jQuery('#list_volumegroup').append(vg_info);
        }
        if (data.length < 1) {
          var vg_top = '<dt class="lvm_open">' +
            '<div class="title"><span style="margin-right:5px;">' + '##$@lvm@$##No Volume Group##$@lvm@$##' + '</span></div>' +
            '</dt>';
          var lv_content = '<dd><div class="content"><ul style="margin-right:-20px;"><li>' +
            '<div class="clearvgcontent"></div>' +
            '</li></ul></div></dd>';
          var vg_info = vg_top + lv_content;
          jQuery('#list_volumegroup').append(vg_info);
        }

        lvmTranslator('list_volumegroup');
        jQuery('#lvm_manager_waiting_content').attr("style", "display: none");
        jQuery('#lvm_manager_waiting_logo').attr("style", "display: none");
        resolve(result);
        lock_exists();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        jQuery('#lvm_manager_waiting_content').attr("style", "display:none");
        jQuery('#lvm_manager_waiting_logo').attr("style", "display:none");
      }
    });
  })

}

function lvmSnapshotWindowFun(lv, vm, fstype) {
  var SnapshotW = new MUI.Modal({
    id: 'SnapshotWindow',
    title: window.top.UNAS._('##$@lvm@$##Snapshot Manager##$@lvm@$##'),
    modal: true,
    width: 930,
    height: 550,
    modalOverlayClose: false,
    onClose: function() {},
    contentURL: '/apps/lvm/snapshot/snapshot.html?v=6.1.13&zpoolname=' + lv + '&zfilesysname=' + vm +'&fstype=' + fstype
  });

}

// 格式化size
function formSize(bytes, decimalPoint) {
  var num = bytes;
  if (typeof(num) !== "number") {
    num = parseInt(num)
  }
  if (num <= 0) return '0 Bytes';
  var k = 1024,
    dm = decimalPoint || 2,
    sizes = ['KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB', 'BB'],
    i = Math.floor(Math.log(num) / Math.log(k));
  return parseFloat((num / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

function mountLv(vg, lv, crypt) {
  var m_id = "mountlv" + vg + "-" + lv;
  var b_id = "percentagebox" + vg + "-" + lv;
  var bimg_id = "percentageimg" + vg + "-" + lv;
  var d_id = "deletelv" + vg + "-" + lv;
  var selfclass = jQuery("#" + m_id).attr("class");
  if (selfclass == "umount") {
    var UmountLvW = new MUI.Modal({
      id: 'UmountLvWindow',
      title: UNAS._('##$@lvm@$##Umount Volume##$@lvm@$##'),
      modal: true,
      modalOverlayClose: false,
      width: 400,
      height: 220,
      contentURL: '/apps/lvm/umount_lv.html?v=6.1.13&vgname=' + vg + '&lvname=' + lv + '&crypt=' + crypt
    });
    UmountLvW.ProcessUmountLv = function() {
      getVGsInfo(vg);
    }
  }
  if (selfclass == "mount") {
    var MountLvW = new MUI.Modal({
      id: 'MountLvWindow',
      title: UNAS._('##$@lvm@$##Mount Volume##$@lvm@$##'),
      modal: true,
      modalOverlayClose: false,
      width: 400,
      height: 220,
      contentURL: '/apps/lvm/mount_lv.html?v=6.1.13&vgname=' + vg + '&lvname=' + lv + '&crypt=' + crypt
    });
    MountLvW.ProcessMountLv = function() {
      getVGsInfo(vg);
    }
  }
}

function openCloseVgWindow(e, i) {
  var class_name = jQuery(e).attr("class");
  if (class_name == "close_img") {
    jQuery("#vg_dt_" + i).attr("class", "lvm_close");
    jQuery(e).attr("class", "open_img");
    jQuery("#vg_dd_" + i).attr("style", "display:none");
  } else {
    jQuery("#vg_dt_" + i).attr("class", "lvm_open");
    jQuery(e).attr("class", "close_img");
    jQuery("#vg_dd_" + i).attr("style", "display:block");
  }
}

function deleteLv(vg, lv, crypt) {
  var d_id = "deletelv" + vg + "-" + lv;
  if (jQuery("#" + d_id).attr("class") != "lv_delete_none") {
    var lvtype = jQuery("#" + d_id).attr("type");
    var DeleteLvW = new MUI.Modal({
      id: 'DeleteLvWindow',
      title: UNAS._('##$@lvm@$##Delete Volume##$@lvm@$##'),
      modal: true,
      width: 400,
      height: 220,
      modalOverlayClose: false,
      contentURL: '/apps/lvm/delete_lv.html?v=6.1.13&vgname=' + vg + '&lvname=' + lv + '&lvtype=' + lvtype + '&crypt=' + crypt
    });
    DeleteLvW.ProcessDeleteLv = function() {
      getVGsInfo(vg);
    }
  }
}

function CreateVgWindowFun() {
  var CreateVGW = new MUI.Modal({
    id: 'CreateVgWindow',
    title: UNAS._('##$@lvm@$##Create Volume Group##$@lvm@$##'),
    modal: true,
    width: 700,
    height: 480,
    modalOverlayClose: false,
    contentURL: '/apps/lvm/create_vg.html?v=6.1.13&'
  });
  CreateVGW.ProcessCreateVg = function() {
    getVGsInfo("");
  }
}

function EditVgWindowFun(vgname, vgsize, vgfreesize) {
  var EditVgW = new MUI.Modal({
    id: 'EditVgWindow',
    title: UNAS._('##$@lvm@$##Edit Volume Group##$@lvm@$##'),
    modal: true,
    width: 886,
    height: 540,
    modalOverlayClose: false,
    contentURL: '/apps/lvm/edit_vg.html?v=6.1.13&vgname=' + vgname + '&vgsize=' + vgsize + "&vgfreesize=" + vgfreesize
  });
  EditVgW.ProcessEditVg = function() {
    getVGsInfo(vgname);
  }
}

function DeleteVgWindowFun(vgname) {
  var DeleteVgW = new MUI.Modal({
    id: 'DeleteVgWindow',
    title: UNAS._('##$@lvm@$##Delete Volume Group##$@lvm@$##'),
    modal: true,
    width: 400,
    height: 220,
    modalOverlayClose: false,
    contentURL: '/apps/lvm/delete_vg.html?v=6.1.13&vgname=' + vgname
  });
  DeleteVgW.ProcessDeleteVg = function() {
    getVGsInfo(vgname);
  }
}

function CreateLvWindowFun(vgname, vgsize, vgfreesize) {
  var CreateLvW = new MUI.Modal({
    id: 'CreateLvWindow',
    title: UNAS._('##$@lvm@$##Create Volume##$@lvm@$##'),
    modal: true,
    width: 650,
    height: 500,
    modalOverlayClose: false,
    contentURL: '/apps/lvm/create_lv.html?v=6.1.13&vgname=' + vgname + '&vgsize=' + vgsize + "&vgfreesize=" + vgfreesize
  });
  CreateLvW.ProcessCreateLv = function() {
    getVGsInfo(vgname);
  }
}

function EditLvWindowFun(vgname, lvname, vgfreesize) {
  var EditLvW = new MUI.Modal({
    id: 'EditLvWindow',
    title: UNAS._('##$@lvm@$##Edit Volume##$@lvm@$##'),
    modal: true,
    width: 650,
    height: 460,
    modalOverlayClose: false,
    contentURL: '/apps/lvm/edit_lv.html?v=6.1.13&vgname=' + vgname + '&lvname=' + lvname + "&vgfreesize=" + vgfreesize
  });
  EditLvW.ProcessEditLv = function() {
    getVGsInfo(vgname);
  }
}

function execFailure(title, op, c) {
  var execFailureWindow = new MUI.Modal({
    id: 'jv-execFailureWindow',
    title: UNAS._(title),
    contentURL: "/apps/lvm/exec_failure.html?v=6.1.13&c=" + c + '&op=' + op,
    modal: true,
    width: 400,
    height: 130,
  });
}

function vgcacheFaulty() {
  jQuery.ajax({
    url: '/wmi/index.php',
    type: "POST",
    async: true,
    dataType: 'json',
    data: JSON.stringify({
      token: UToken,
      cmd: 'vgcache_faulty'
    }),
    timeout: TIMEOUT,
    success: function(res) {
      var info = res.results || {};
      if (res.err == 9951) {
        jQuery('#jv-vgcacheSecedeBtn').show().on('click', function() {
          vgcacheSecedeFn(info.reboot || 0);
        })
      } else {
        jQuery('#jv-vgcacheSecedeBtn').hide();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(UNAS._(textStatus));

    }
  });
}

function vgcacheSecedeFn(r) {

  new MUI.Modal({
    id: 'jv-vgcacheSecedeWindow',
    title: UNAS._('##$@lvm@$##Detaching the faulty cache disk##$@lvm@$##'),
    modal: true,
    width: 400,
    height: 190,
    data: {
      reboot: r
    },
    modalOverlayClose: false,
    contentURL: '/apps/lvm/vgcache_secede.html?v=6.1.13',
  });
}

function th_alertWindowFn(data, fn) {
  var url = '/apps/lvm/confirmaert.html?=v=6.1.13&'
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(data.title || 'Tip'),
    modal: true,
    modalOverlayClose: false,
    width: 350,
    height: 160,
    data: data,
    contentURL: url
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function templateAppend_lvm(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

(function() {

  getVGsInfo("").then(function(res){
    var info = res.results || {};
    var vgs = info.vgs || {};

    for (var v in vgs) {
      if (vgs.hasOwnProperty(v)) {
        for (var j in vgs[v].lvs) {
          if (vgs[v].lvs.hasOwnProperty(j)) {

            if (!vgs[v].lvs[j].snap) {
               updata_created(vgs[v].vg, vgs[v].lvs[j].lv);
            }
            
          }
        }
      }
    }

  });

  jQuery('#CreateVg').click(function() {
    CreateVgWindowFun();
  });
  jQuery("#lvm_manager_vg_list").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  vgcacheFaulty();
})();
